summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorRichard Ipsum <richard.ipsum@codethink.co.uk>2013-12-13 15:58:13 +0000
committerRichard Ipsum <richard.ipsum@codethink.co.uk>2013-12-17 15:19:49 +0000
commit7d1e928ec4fad95ba0293d68803f7a4c7b833c3c (patch)
treefa99004af06bb72e1b80d889ca918bbaa532e69e
parentaa13f5347d3c4bdb7797e2a2f5b53f8101200375 (diff)
downloadlorry-7d1e928ec4fad95ba0293d68803f7a4c7b833c3c.tar.gz
Add test: existing backup is removed by default
-rwxr-xr-xtests/git-backup-on-error-single-backup-is-removed-if-exists.script43
-rwxr-xr-xtests/git-backup-on-error-single-backup-is-removed-if-exists.setup47
-rwxr-xr-xtests/git-backup-on-error-single-backup-is-removed-if-exists.teardown21
3 files changed, 111 insertions, 0 deletions
diff --git a/tests/git-backup-on-error-single-backup-is-removed-if-exists.script b/tests/git-backup-on-error-single-backup-is-removed-if-exists.script
new file mode 100755
index 0000000..2730003
--- /dev/null
+++ b/tests/git-backup-on-error-single-backup-is-removed-if-exists.script
@@ -0,0 +1,43 @@
+#!/bin/bash
+#
+# Tests when a git mirror fails that it keeps the backups around
+#
+# Copyright (C) 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+
+set -e
+set -o pipefail
+
+repo_name="git-backup-test-repo"
+logfile="$DATADIR/$repo_name.log"
+workdir="$DATADIR/work-dir"
+repo="$DATADIR/$repo_name"
+prebackup="$workdir/$repo_name/git-pre-update"
+postbackup="$workdir/$repo_name/git-post-fail"
+
+# create backup dirs
+#(lorry must not fail to make a new backup if backup dirs already exist)
+mkdir -p "$prebackup" "$postbackup"
+
+# mirror some history
+"${SRCDIR}/test-lorry" --pull-only --log="$logfile" --working-area="$workdir" --bundle=never \
+ "$DATADIR/git-backup-test-repo.lorry"
+
+if [ -e "$prebackup" ] || [ -e "$postbackup" ]
+then
+ echo "Lorry should remove existing backup directories" >&2
+ exit 1
+fi
diff --git a/tests/git-backup-on-error-single-backup-is-removed-if-exists.setup b/tests/git-backup-on-error-single-backup-is-removed-if-exists.setup
new file mode 100755
index 0000000..81c0a49
--- /dev/null
+++ b/tests/git-backup-on-error-single-backup-is-removed-if-exists.setup
@@ -0,0 +1,47 @@
+#!/bin/sh
+#
+# Creates a git repository with a single file and a single commit.
+#
+# Copyright (C) 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+
+set -e
+
+# create the repository
+repo="$DATADIR/git-backup-test-repo"
+mkdir "$repo"
+cd "$repo"
+git init --quiet
+
+# add the test file
+echo "first line" > test.txt
+git add test.txt
+
+# make a commit
+git commit --quiet -m "first commit"
+
+# create the .lorry file for the repository
+cat <<EOF > $DATADIR/git-backup-test-repo.lorry
+{
+ "git-backup-test-repo": {
+ "type": "git",
+ "url": "file://$repo"
+ }
+}
+EOF
+
+# create the working directory
+test -d "$DATADIR/work-dir" || mkdir "$DATADIR/work-dir"
diff --git a/tests/git-backup-on-error-single-backup-is-removed-if-exists.teardown b/tests/git-backup-on-error-single-backup-is-removed-if-exists.teardown
new file mode 100755
index 0000000..7c73c04
--- /dev/null
+++ b/tests/git-backup-on-error-single-backup-is-removed-if-exists.teardown
@@ -0,0 +1,21 @@
+#!/bin/bash
+#
+# Tests when a git mirror fails that it keeps the backups around
+#
+# Copyright (C) 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+
+rm -r "$DATADIR/git-backup-test-repo.log" "$DATADIR/work-dir"